diff --git a/guava-gwt/test/com/google/common/collect/StreamsTest_gwt.java b/guava-gwt/test/com/google/common/collect/StreamsTest_gwt.java
index eace8c0b97..998f1f4ae4 100644
--- a/guava-gwt/test/com/google/common/collect/StreamsTest_gwt.java
+++ b/guava-gwt/test/com/google/common/collect/StreamsTest_gwt.java
@@ -18,6 +18,26 @@
 @Override public String getModuleName() {
   return "com.google.common.collect.testModule";
 }
+public void testConcatInfiniteStream() throws Exception {
+  com.google.common.collect.StreamsTest testCase = new com.google.common.collect.StreamsTest();
+  testCase.testConcatInfiniteStream();
+}
+
+public void testConcatInfiniteStream_double() throws Exception {
+  com.google.common.collect.StreamsTest testCase = new com.google.common.collect.StreamsTest();
+  testCase.testConcatInfiniteStream_double();
+}
+
+public void testConcatInfiniteStream_int() throws Exception {
+  com.google.common.collect.StreamsTest testCase = new com.google.common.collect.StreamsTest();
+  testCase.testConcatInfiniteStream_int();
+}
+
+public void testConcatInfiniteStream_long() throws Exception {
+  com.google.common.collect.StreamsTest testCase = new com.google.common.collect.StreamsTest();
+  testCase.testConcatInfiniteStream_long();
+}
+
 public void testConcat_doubleStream() throws Exception {
   com.google.common.collect.StreamsTest testCase = new com.google.common.collect.StreamsTest();
   testCase.testConcat_doubleStream();
diff --git a/guava-tests/test/com/google/common/collect/StreamsTest.java b/guava-tests/test/com/google/common/collect/StreamsTest.java
index e419d3e0d8..9d3dab65a4 100644
--- a/guava-tests/test/com/google/common/collect/StreamsTest.java
+++ b/guava-tests/test/com/google/common/collect/StreamsTest.java
@@ -172,6 +172,30 @@ public void testStream_optionalDouble() {
     assertThat(stream(OptionalDouble.of(5.0))).containsExactly(5.0);
   }
 
+  public void testConcatInfiniteStream() {
+    assertThat(Streams.concat(Stream.of(1, 2, 3), Stream.generate(() -> 5)).limit(5))
+        .containsExactly(1, 2, 3, 5, 5)
+        .inOrder();
+  }
+
+  public void testConcatInfiniteStream_int() {
+    assertThat(Streams.concat(IntStream.of(1, 2, 3), IntStream.generate(() -> 5)).limit(5))
+        .containsExactly(1, 2, 3, 5, 5)
+        .inOrder();
+  }
+
+  public void testConcatInfiniteStream_long() {
+    assertThat(Streams.concat(LongStream.of(1, 2, 3), LongStream.generate(() -> 5)).limit(5))
+        .containsExactly(1L, 2L, 3L, 5L, 5L)
+        .inOrder();
+  }
+
+  public void testConcatInfiniteStream_double() {
+    assertThat(Streams.concat(DoubleStream.of(1, 2, 3), DoubleStream.generate(() -> 5)).limit(5))
+        .containsExactly(1., 2., 3., 5., 5.)
+        .inOrder();
+  }
+
   private void testMapWithIndex(Function<Collection<String>, Stream<String>> collectionImpl) {
     SpliteratorTester.of(
             () ->
diff --git a/guava/src/com/google/common/collect/CollectSpliterators.java b/guava/src/com/google/common/collect/CollectSpliterators.java
index dcb5b46cc3..2b718aa133 100644
--- a/guava/src/com/google/common/collect/CollectSpliterators.java
+++ b/guava/src/com/google/common/collect/CollectSpliterators.java
@@ -20,12 +20,15 @@
 import static com.google.common.base.Preconditions.checkNotNull;
 
 import com.google.common.annotations.GwtCompatible;
+import com.google.j2objc.annotations.Weak;
 import java.util.Comparator;
 import java.util.Spliterator;
 import java.util.function.Consumer;
+import java.util.function.DoubleConsumer;
 import java.util.function.Function;
 import java.util.function.IntConsumer;
 import java.util.function.IntFunction;
+import java.util.function.LongConsumer;
 import java.util.function.Predicate;
 import java.util.stream.IntStream;
 import org.checkerframework.checker.nullness.qual.Nullable;
@@ -207,84 +210,270 @@ public int characteristics() {
         "flatMap does not support SORTED characteristic");
     checkNotNull(fromSpliterator);
     checkNotNull(function);
-    class FlatMapSpliterator implements Spliterator<T> {
-      @Nullable Spliterator<T> prefix;
-      final Spliterator<F> from;
-      int characteristics;
-      long estimatedSize;
-
-      FlatMapSpliterator(
-          Spliterator<T> prefix, Spliterator<F> from, int characteristics, long estimatedSize) {
-        this.prefix = prefix;
-        this.from = from;
-        this.characteristics = characteristics;
-        this.estimatedSize = estimatedSize;
-      }
+    return new FlatMapSpliterator<F, T, Spliterator<T>>(
+        null, fromSpliterator, function, topCharacteristics, topSize);
+  }
 
-      @Override
-      public boolean tryAdvance(Consumer<? super T> action) {
-        while (true) {
-          if (prefix != null && prefix.tryAdvance(action)) {
-            if (estimatedSize != Long.MAX_VALUE) {
-              estimatedSize--;
-            }
-            return true;
-          } else {
-            prefix = null;
-          }
-          if (!from.tryAdvance(fromElement -> prefix = function.apply(fromElement))) {
-            return false;
+  /**
+   * Returns a {@code Spliterator.OfInt} that iterates over the elements of the spliterators
+   * generated by applying {@code function} to the elements of {@code fromSpliterator}.
+   */
+  static <F> Spliterator.OfInt flatMapToInt(
+      Spliterator<F> fromSpliterator,
+      Function<? super F, Spliterator.OfInt> function,
+      int topCharacteristics,
+      long topSize) {
+    checkArgument(
+        (topCharacteristics & Spliterator.SUBSIZED) == 0,
+        "flatMap does not support SUBSIZED characteristic");
+    checkArgument(
+        (topCharacteristics & Spliterator.SORTED) == 0,
+        "flatMap does not support SORTED characteristic");
+    checkNotNull(fromSpliterator);
+    checkNotNull(function);
+    return new FlatMapSpliteratorOfInt<F>(
+        null, fromSpliterator, function, topCharacteristics, topSize);
+  }
+
+  /**
+   * Returns a {@code Spliterator.OfLong} that iterates over the elements of the spliterators
+   * generated by applying {@code function} to the elements of {@code fromSpliterator}.
+   */
+  static <F> Spliterator.OfLong flatMapToLong(
+      Spliterator<F> fromSpliterator,
+      Function<? super F, Spliterator.OfLong> function,
+      int topCharacteristics,
+      long topSize) {
+    checkArgument(
+        (topCharacteristics & Spliterator.SUBSIZED) == 0,
+        "flatMap does not support SUBSIZED characteristic");
+    checkArgument(
+        (topCharacteristics & Spliterator.SORTED) == 0,
+        "flatMap does not support SORTED characteristic");
+    checkNotNull(fromSpliterator);
+    checkNotNull(function);
+    return new FlatMapSpliteratorOfLong<F>(
+        null, fromSpliterator, function, topCharacteristics, topSize);
+  }
+
+  /**
+   * Returns a {@code Spliterator.OfDouble} that iterates over the elements of the spliterators
+   * generated by applying {@code function} to the elements of {@code fromSpliterator}.
+   */
+  static <F> Spliterator.OfDouble flatMapToDouble(
+      Spliterator<F> fromSpliterator,
+      Function<? super F, Spliterator.OfDouble> function,
+      int topCharacteristics,
+      long topSize) {
+    checkArgument(
+        (topCharacteristics & Spliterator.SUBSIZED) == 0,
+        "flatMap does not support SUBSIZED characteristic");
+    checkArgument(
+        (topCharacteristics & Spliterator.SORTED) == 0,
+        "flatMap does not support SORTED characteristic");
+    checkNotNull(fromSpliterator);
+    checkNotNull(function);
+    return new FlatMapSpliteratorOfDouble<F>(
+        null, fromSpliterator, function, topCharacteristics, topSize);
+  }
+
+  /**
+   * Implements the {@link Stream#flatMap} operation on spliterators.
+   *
+   * @param <F> the element type of the input spliterator
+   * @param <T> the element type of the output spliterators
+   * @param <S> the type of the output spliterators
+   */
+  static class FlatMapSpliterator<F, T, S extends Spliterator<T>> implements Spliterator<T> {
+    @Nullable @Weak S prefix;
+    final Spliterator<F> from;
+    final Function<? super F, S> function;
+    int characteristics;
+    long estimatedSize;
+
+    FlatMapSpliterator(
+        S prefix,
+        Spliterator<F> from,
+        Function<? super F, S> function,
+        int characteristics,
+        long estimatedSize) {
+      this.prefix = prefix;
+      this.from = from;
+      this.function = function;
+      this.characteristics = characteristics;
+      this.estimatedSize = estimatedSize;
+    }
+
+    @Override
+    public boolean tryAdvance(Consumer<? super T> action) {
+      while (true) {
+        if (prefix != null && prefix.tryAdvance(action)) {
+          if (estimatedSize != Long.MAX_VALUE) {
+            estimatedSize--;
           }
+          return true;
+        } else {
+          prefix = null;
+        }
+        if (!from.tryAdvance(fromElement -> prefix = function.apply(fromElement))) {
+          return false;
         }
       }
+    }
 
-      @Override
-      public void forEachRemaining(Consumer<? super T> action) {
-        if (prefix != null) {
-          prefix.forEachRemaining(action);
-          prefix = null;
+    @Override
+    public void forEachRemaining(Consumer<? super T> action) {
+      if (prefix != null) {
+        prefix.forEachRemaining(action);
+        prefix = null;
+      }
+      from.forEachRemaining(fromElement -> function.apply(fromElement).forEachRemaining(action));
+      estimatedSize = 0;
+    }
+
+    @Override
+    public Spliterator<T> trySplit() {
+      Spliterator<F> fromSplit = from.trySplit();
+      if (fromSplit != null) {
+        int splitCharacteristics = characteristics & ~Spliterator.SIZED;
+        long estSplitSize = estimateSize();
+        if (estSplitSize < Long.MAX_VALUE) {
+          estSplitSize /= 2;
+          this.estimatedSize -= estSplitSize;
+          this.characteristics = splitCharacteristics;
         }
-        from.forEachRemaining(fromElement -> function.apply(fromElement).forEachRemaining(action));
-        estimatedSize = 0;
+        Spliterator<T> result = buildSplit(fromSplit, splitCharacteristics, estSplitSize);
+        this.prefix = null;
+        return result;
+      } else if (prefix != null) {
+        Spliterator<T> result = prefix;
+        this.prefix = null;
+        return result;
+      } else {
+        return null;
       }
+    }
 
-      @Override
-      public Spliterator<T> trySplit() {
-        Spliterator<F> fromSplit = from.trySplit();
-        if (fromSplit != null) {
-          int splitCharacteristics = characteristics & ~Spliterator.SIZED;
-          long estSplitSize = estimateSize();
-          if (estSplitSize < Long.MAX_VALUE) {
-            estSplitSize /= 2;
-            this.estimatedSize -= estSplitSize;
-            this.characteristics = splitCharacteristics;
+    FlatMapSpliterator<F, T, S> buildSplit(
+        Spliterator<F> fromSplit, int splitCharacteristics, long estSplitSize) {
+      return new FlatMapSpliterator<>(
+          this.prefix, fromSplit, function, splitCharacteristics, estSplitSize);
+    }
+
+    @Override
+    public long estimateSize() {
+      if (prefix != null) {
+        estimatedSize = Math.max(estimatedSize, prefix.estimateSize());
+      }
+      return Math.max(estimatedSize, 0);
+    }
+
+    @Override
+    public int characteristics() {
+      return characteristics;
+    }
+  }
+
+  /**
+   * Implementation of {@link Stream#flatMap} with a primitive spliterator output type.
+   *
+   * @param <F> the element type of the input spliterator
+   * @param <T> the (boxed) element type of the output spliterators
+   * @param <T_CONS> the specialized consumer type for the primitive output type
+   * @param <S> the primitive spliterator type associated with {@code T}
+   */
+  static class FlatMapSpliteratorOfPrimitive<
+          F, T, T_CONS, S extends Spliterator.OfPrimitive<T, T_CONS, S>>
+      extends FlatMapSpliterator<F, T, S> implements Spliterator.OfPrimitive<T, T_CONS, S> {
+
+    public FlatMapSpliteratorOfPrimitive(
+        S prefix,
+        Spliterator<F> from,
+        Function<? super F, S> function,
+        int characteristics,
+        long estimatedSize) {
+      super(prefix, from, function, characteristics, estimatedSize);
+    }
+
+    @Override
+    public boolean tryAdvance(T_CONS action) {
+      while (true) {
+        if (prefix != null && prefix.tryAdvance(action)) {
+          if (estimatedSize != Long.MAX_VALUE) {
+            estimatedSize--;
           }
-          Spliterator<T> result =
-              new FlatMapSpliterator(this.prefix, fromSplit, splitCharacteristics, estSplitSize);
-          this.prefix = null;
-          return result;
-        } else if (prefix != null) {
-          Spliterator<T> result = prefix;
-          this.prefix = null;
-          return result;
+          return true;
         } else {
-          return null;
+          prefix = null;
         }
-      }
-
-      @Override
-      public long estimateSize() {
-        if (prefix != null) {
-          estimatedSize = Math.max(estimatedSize, prefix.estimateSize());
+        if (!from.tryAdvance(fromElement -> prefix = function.apply(fromElement))) {
+          return false;
         }
-        return Math.max(estimatedSize, 0);
       }
+    }
 
-      @Override
-      public int characteristics() {
-        return characteristics;
+    @Override
+    public S trySplit() {
+      return (S) super.trySplit();
+    }
+
+    @Override
+    public void forEachRemaining(T_CONS action) {
+      if (prefix != null) {
+        prefix.forEachRemaining(action);
+        prefix = null;
       }
+      from.forEachRemaining(fromElement -> function.apply(fromElement).forEachRemaining(action));
+      estimatedSize = 0;
+    }
+
+    @Override
+    FlatMapSpliteratorOfPrimitive<F, T, T_CONS, S> buildSplit(
+        Spliterator<F> fromSplit, int splitCharacteristics, long estSplitSize) {
+      return new FlatMapSpliteratorOfPrimitive<>(
+          this.prefix, fromSplit, function, splitCharacteristics, estSplitSize);
+    }
+  }
+
+  /** Implementation of {@link #flatMapToInt}. */
+  static class FlatMapSpliteratorOfInt<F>
+      extends FlatMapSpliteratorOfPrimitive<F, Integer, IntConsumer, Spliterator.OfInt>
+      implements Spliterator.OfInt {
+    FlatMapSpliteratorOfInt(
+        Spliterator.OfInt prefix,
+        Spliterator<F> from,
+        Function<? super F, Spliterator.OfInt> function,
+        int characteristics,
+        long estimatedSize) {
+      super(prefix, from, function, characteristics, estimatedSize);
+    }
+  }
+
+  /** Implementation of {@link #flatMapToLong}. */
+  static class FlatMapSpliteratorOfLong<F>
+      extends FlatMapSpliteratorOfPrimitive<F, Long, LongConsumer, Spliterator.OfLong>
+      implements Spliterator.OfLong {
+    FlatMapSpliteratorOfLong(
+        Spliterator.OfLong prefix,
+        Spliterator<F> from,
+        Function<? super F, Spliterator.OfLong> function,
+        int characteristics,
+        long estimatedSize) {
+      super(prefix, from, function, characteristics, estimatedSize);
+    }
+  }
+
+  /** Implementation of {@link #flatMapToDouble}. */
+  static class FlatMapSpliteratorOfDouble<F>
+      extends FlatMapSpliteratorOfPrimitive<F, Double, DoubleConsumer, Spliterator.OfDouble>
+      implements Spliterator.OfDouble {
+    FlatMapSpliteratorOfDouble(
+        Spliterator.OfDouble prefix,
+        Spliterator<F> from,
+        Function<? super F, Spliterator.OfDouble> function,
+        int characteristics,
+        long estimatedSize) {
+      super(prefix, from, function, characteristics, estimatedSize);
     }
-    return new FlatMapSpliterator(null, fromSpliterator, topCharacteristics, topSize);
   }
 }
diff --git a/guava/src/com/google/common/collect/Streams.java b/guava/src/com/google/common/collect/Streams.java
index d4b2929991..620a6e773c 100644
--- a/guava/src/com/google/common/collect/Streams.java
+++ b/guava/src/com/google/common/collect/Streams.java
@@ -39,6 +39,7 @@
 import java.util.function.DoubleConsumer;
 import java.util.function.IntConsumer;
 import java.util.function.LongConsumer;
+import java.util.stream.BaseStream;
 import java.util.stream.DoubleStream;
 import java.util.stream.IntStream;
 import java.util.stream.LongStream;
@@ -130,6 +131,12 @@ public static DoubleStream stream(OptionalDouble optional) {
     return optional.isPresent() ? DoubleStream.of(optional.getAsDouble()) : DoubleStream.empty();
   }
 
+  private static void closeAll(BaseStream<?, ?>[] toClose) {
+    for (BaseStream<?, ?> stream : toClose) {
+      stream.close();
+    }
+  }
+
   /**
    * Returns a {@link Stream} containing the elements of the first stream, followed by the elements
    * of the second stream, and so on.
@@ -161,12 +168,7 @@ public static DoubleStream stream(OptionalDouble optional) {
                 characteristics,
                 estimatedSize),
             isParallel)
-        .onClose(
-            () -> {
-              for (Stream<? extends T> stream : streams) {
-                stream.close();
-              }
-            });
+        .onClose(() -> closeAll(streams));
   }
 
   /**
@@ -179,8 +181,26 @@ public static DoubleStream stream(OptionalDouble optional) {
    * @see IntStream#concat(IntStream, IntStream)
    */
   public static IntStream concat(IntStream... streams) {
-    // TODO(lowasser): optimize this later
-    return Stream.of(streams).flatMapToInt(stream -> stream);
+    boolean isParallel = false;
+    int characteristics = Spliterator.ORDERED | Spliterator.SIZED | Spliterator.NONNULL;
+    long estimatedSize = 0L;
+    ImmutableList.Builder<Spliterator.OfInt> splitrsBuilder =
+        new ImmutableList.Builder<>(streams.length);
+    for (IntStream stream : streams) {
+      isParallel |= stream.isParallel();
+      Spliterator.OfInt splitr = stream.spliterator();
+      splitrsBuilder.add(splitr);
+      characteristics &= splitr.characteristics();
+      estimatedSize = LongMath.saturatedAdd(estimatedSize, splitr.estimateSize());
+    }
+    return StreamSupport.intStream(
+            CollectSpliterators.flatMapToInt(
+                splitrsBuilder.build().spliterator(),
+                splitr -> splitr,
+                characteristics,
+                estimatedSize),
+            isParallel)
+        .onClose(() -> closeAll(streams));
   }
 
   /**
@@ -193,8 +213,26 @@ public static IntStream concat(IntStream... streams) {
    * @see LongStream#concat(LongStream, LongStream)
    */
   public static LongStream concat(LongStream... streams) {
-    // TODO(lowasser): optimize this later
-    return Stream.of(streams).flatMapToLong(stream -> stream);
+    boolean isParallel = false;
+    int characteristics = Spliterator.ORDERED | Spliterator.SIZED | Spliterator.NONNULL;
+    long estimatedSize = 0L;
+    ImmutableList.Builder<Spliterator.OfLong> splitrsBuilder =
+        new ImmutableList.Builder<>(streams.length);
+    for (LongStream stream : streams) {
+      isParallel |= stream.isParallel();
+      Spliterator.OfLong splitr = stream.spliterator();
+      splitrsBuilder.add(splitr);
+      characteristics &= splitr.characteristics();
+      estimatedSize = LongMath.saturatedAdd(estimatedSize, splitr.estimateSize());
+    }
+    return StreamSupport.longStream(
+            CollectSpliterators.flatMapToLong(
+                splitrsBuilder.build().spliterator(),
+                splitr -> splitr,
+                characteristics,
+                estimatedSize),
+            isParallel)
+        .onClose(() -> closeAll(streams));
   }
 
   /**
@@ -207,8 +245,26 @@ public static LongStream concat(LongStream... streams) {
    * @see DoubleStream#concat(DoubleStream, DoubleStream)
    */
   public static DoubleStream concat(DoubleStream... streams) {
-    // TODO(lowasser): optimize this later
-    return Stream.of(streams).flatMapToDouble(stream -> stream);
+    boolean isParallel = false;
+    int characteristics = Spliterator.ORDERED | Spliterator.SIZED | Spliterator.NONNULL;
+    long estimatedSize = 0L;
+    ImmutableList.Builder<Spliterator.OfDouble> splitrsBuilder =
+        new ImmutableList.Builder<>(streams.length);
+    for (DoubleStream stream : streams) {
+      isParallel |= stream.isParallel();
+      Spliterator.OfDouble splitr = stream.spliterator();
+      splitrsBuilder.add(splitr);
+      characteristics &= splitr.characteristics();
+      estimatedSize = LongMath.saturatedAdd(estimatedSize, splitr.estimateSize());
+    }
+    return StreamSupport.doubleStream(
+            CollectSpliterators.flatMapToDouble(
+                splitrsBuilder.build().spliterator(),
+                splitr -> splitr,
+                characteristics,
+                estimatedSize),
+            isParallel)
+        .onClose(() -> closeAll(streams));
   }
 
   /**
